Index: cards/CMS_PhaseII/CMS_PhaseII_Substructure_PIX4022_0PU.tcl
===================================================================
--- cards/CMS_PhaseII/CMS_PhaseII_Substructure_PIX4022_0PU.tcl	(revision d759c469f5683fc50b0825bae74651555f89dfab)
+++ cards/CMS_PhaseII/CMS_PhaseII_Substructure_PIX4022_0PU.tcl	(revision fc02d598d13afb39bf4ffce62f80747418c9ce71)
@@ -47,4 +47,5 @@
   LeptonFilterLep
   RunPUPPIBase
+  RunPUPPIMerger
   RunPUPPI
 
@@ -134,4 +135,5 @@
   # pre-generated minbias input file
   set PileUpFile ../eos/cms/store/group/upgrade/delphes/PhaseII/MinBias_100k.pileup
+  #set PileUpFile MinBias.pileup
 
   # average expected pile up
@@ -651,7 +653,13 @@
 }
 
-module Merger RunPUPPI {
+module Merger RunPUPPIMerger {
   add InputArray RunPUPPIBase/PuppiParticles
   add InputArray LeptonFilterLep/eflowTracksLeptons
+  set OutputArray PuppiParticles
+}
+
+# need this because of leptons that were added back
+module RecoPuFilter RunPUPPI {
+  set InputArray RunPUPPIMerger/PuppiParticles
   set OutputArray PuppiParticles
 }
Index: cards/CMS_PhaseII/CMS_PhaseII_Substructure_PIX4022_200PU.tcl
===================================================================
--- cards/CMS_PhaseII/CMS_PhaseII_Substructure_PIX4022_200PU.tcl	(revision d759c469f5683fc50b0825bae74651555f89dfab)
+++ cards/CMS_PhaseII/CMS_PhaseII_Substructure_PIX4022_200PU.tcl	(revision fc02d598d13afb39bf4ffce62f80747418c9ce71)
@@ -47,4 +47,5 @@
   LeptonFilterLep
   RunPUPPIBase
+  RunPUPPIMerger
   RunPUPPI
 
@@ -134,4 +135,5 @@
   # pre-generated minbias input file
   set PileUpFile ../eos/cms/store/group/upgrade/delphes/PhaseII/MinBias_100k.pileup
+  #set PileUpFile MinBias.pileup
 
   # average expected pile up
@@ -651,7 +653,13 @@
 }
 
-module Merger RunPUPPI {
+module Merger RunPUPPIMerger {
   add InputArray RunPUPPIBase/PuppiParticles
   add InputArray LeptonFilterLep/eflowTracksLeptons
+  set OutputArray PuppiParticles
+}
+
+# need this because of leptons that were added back
+module RecoPuFilter RunPUPPI {
+  set InputArray RunPUPPIMerger/PuppiParticles
   set OutputArray PuppiParticles
 }
Index: cards/FCC/FCChh_PileUp.tcl
===================================================================
--- cards/FCC/FCChh_PileUp.tcl	(revision d759c469f5683fc50b0825bae74651555f89dfab)
+++ cards/FCC/FCChh_PileUp.tcl	(revision fc02d598d13afb39bf4ffce62f80747418c9ce71)
@@ -42,4 +42,5 @@
   LeptonFilterLep
   RunPUPPIBase
+  RunPUPPIMerger
   RunPUPPI
   
@@ -98,5 +99,5 @@
   
   # average expected pile up
-  set MeanPileUp 1000
+  set MeanPileUp 100
 
   # maximum spread in the beam direction in m
@@ -539,7 +540,13 @@
 }
 
-module Merger RunPUPPI {
+module Merger RunPUPPIMerger {
   add InputArray RunPUPPIBase/PuppiParticles
   add InputArray LeptonFilterLep/eflowTracksLeptons
+  set OutputArray PuppiParticles
+}
+
+# need this because of leptons that were added back
+module RecoPuFilter RunPUPPI {
+  set InputArray RunPUPPIMerger/PuppiParticles
   set OutputArray PuppiParticles
 }
@@ -760,5 +767,5 @@
 
   # isolation collection
-  set IsolationInputArray EFlowFilter/eflow
+  set IsolationInputArray RunPUPPI/PuppiParticles
 
   # output array
@@ -788,7 +795,11 @@
 module Isolation ElectronIsolation {
   set CandidateInputArray ElectronFilter/electrons
-  set IsolationInputArray EFlowFilter/eflow
+  set IsolationInputArray RunPUPPI/PuppiParticles
 
   set OutputArray electrons
+
+  # veto isolation cand. based on proximity to input cand.
+  set DeltaRMin 0.01
+  set UseMiniCone true
 
   set DeltaRMax 0.3
@@ -808,7 +819,11 @@
 module Isolation MuonIsolation {
   set CandidateInputArray MuonMomentumSmearing/muons
-  set IsolationInputArray EFlowFilter/eflow
+  set IsolationInputArray RunPUPPI/PuppiParticles
 
   set OutputArray muons
+
+  # veto isolation cand. based on proximity to input cand.
+  set DeltaRMin 0.01
+  set UseMiniCone true
 
   set DeltaRMax 0.3
@@ -983,4 +998,5 @@
   add Branch GenJetFinder/jets GenJet Jet
   add Branch GenMissingET/momentum GenMissingET MissingET
+  add Branch GenPileUpMissingET/momentum GenPileUpMissingET MissingET
 
   add Branch UniqueObjectFinder/photons Photon Photon
@@ -990,4 +1006,5 @@
 
   add Branch MissingET/momentum MissingET MissingET
+  add Branch PuppiMissingET/momentum PuppiMissingET MissingET
   add Branch ScalarHT/energy ScalarHT ScalarHT
 }
